<?php

namespace Entities;

use Doctrine\ORM\EntityRepository;

/**
 * SinistreRepository
 *
 * This class was generated by the Doctrine ORM. Add your own custom
 * repository methods below.
 */
class SinistreRepository extends EntityRepository {

	public function getNonSynchros() {
		$em = $this->getEntityManager();
		$qb = $em->createQueryBuilder();
		$qb->select('s')
				->from('Entities\Sinistre', 's')
                                ->join('s.affaire', 'a')
				->where($qb->expr()->isNull('s.date_derniere_synchro'))
				->andWhere($qb->expr()->isNotNull('s.token_asqua'))
//				->andWhere($qb->expr()->isNull('s.flag_sinistre_desactive'))
				->andWhere('s.flag_sinistre_desactive is NULL or s.flag_sinistre_desactive = false')
                                //->andWhere($qb->expr()->neq('s.statut', 5))
                                ->andWhere($qb->expr()->neq('a.id', 29))
				->orderBy('s.date_declaration');
		$sinistres = $qb->getQuery()->getResult();

		$fileR = $em->getRepository('Entities\File');
		$type = $em->getRepository('Entities\Type_docs')->find(22);

		foreach ($sinistres as $sinistre) {
			$declaration = $fileR->findOneBy(array("sinistre" => $sinistre, "num_type" => 101));
			$sinistre->declaration = $declaration;
		}

		return $sinistres;
	}

	public function getStatuts($id) {
		$em = $this->getEntityManager();
		$sinistre = $this->find($id);

		$statuts[] = $sinistre->getDo();
		$statuts[] = $sinistre->getAv1();
		$statuts[] = $sinistre->getJudiciaire();
		$statuts[] = $sinistre->getAmiable();

		return $statuts;
	}

	public function getMails($id) {

		$em = $this->getEntityManager();
		$statuts = $this->getStatuts($id);

		$histRepo = $em->getRepository('Entities\Historique');

		$mails = $histRepo->findBy(array('statut' => $statuts), array('date' => 'desc'));
		return $mails;
	}

	public function getMemos($id) {

		$em = $this->getEntityManager();
		$qb = $em->createQueryBuilder();

		$req = $qb->select('m')
				->from('Entities\Memo', 'm')
				->where($qb->expr()->in('m.statut', '?1'))
				->orWhere($qb->expr()->eq('m.sinistre', '?2'))
				->setParameter(1, $this->getStatuts($id))
				->setParameter(2, $id);

		$memos = $qb->getQuery()->getResult();
		return $memos;
	}

	public function get_next_chrono($affaire) {

		$em = $this->getEntityManager();
		$qb = $em->createQueryBuilder();

		$req = $qb->select('MAX(s.num_chrono) as current_chrono')
				->from('Entities\Sinistre', 's')
				->where($qb->expr()->eq('s.affaire', '?1'))
                                ->andWhere($qb->expr()->orX(
                                        $qb->expr()->isNull('s.flag_sinistre_desactive'),
                                        $qb->expr()->neq('s.flag_sinistre_desactive', 1)))
				->setParameter(1, $affaire);

		$result = $qb->getQuery()->getResult();
		return $result[0]['current_chrono'] + 1;
	}

	public function newDo() {
		$do = new Statut_DO();
		$expert = new Contact();
		$cabexpert = new Contact();
		$adresse = new Adresse();
		$cabexpert->setAdresse($adresse);
		$do->setCabinet_expert($cabexpert);
		$do->setContact_expert($expert);

		return $do;
	}

	public function newAv1() {
		$av1 = new Statut_AV1();
		$expert = new Contact;
		$cabexpert = new Contact();
		$adresse_expert = new Adresse();
		$expertcie = new Contact();
		$cabexpertcie = new Contact();
		$adresse_cie = new Adresse();

		$cabexpert->setAdresse($adresse_expert);
		$cabexpertcie->setAdresse($adresse_cie);

		$av1->setCabinet_expert($cabexpert);
		$av1->setContact_expert($expert);
		$av1->setCabinet_expert_compagnie($cabexpertcie);
		$av1->setContact_expert_compagnie($expertcie);

		return $av1;
	}

	public function newJud() {
		$jud = new Statut_judiciaire();

		$expert = new Contact();
		$adresse_expert = new Adresse();
		$expert_cie = new Contact();
		$cabexpertcie = new Contact();
		$adresse_cie = new Adresse();
		$cabavocat = new Contact();
		$adresse_avocat = new Adresse();
		$avocat = new Contact();
		$collab_avocat = new Contact();

		$expert->setAdresse($adresse_expert);
		$cabexpertcie->setAdresse($adresse_cie);
		$cabavocat->setAdresse($adresse_avocat);

		$jud->setExpert_judiciaire($expert);
		$jud->setExpert_compagnie_judiciaire($expert_cie);
		$jud->setCabinet_expert_compagnie_judiciaire($cabexpertcie);
		$jud->setCabinet_avocat($cabavocat);
		$jud->setAvocat_dossier($avocat);
		$jud->setCollaborateur_avocat_dossier($collab_avocat);

		return $jud;
	}

	public function newAmiable() {
		$amiable = new Statut_amiable();

		$cabexpert = new Contact();
		$expert = new Contact();
		$adresse = new Adresse();

		$cabexpert->setAdresse($adresse);

		$amiable->setCabinet_expert_compagnie($cabexpert);
		$amiable->setExpert_compagnie($expert);

		return $amiable;
	}

	public function newRp() {
		$rp = new Statut_rp();

		$expert = new Contact();
		$adresse = new Adresse();

		$expert->setAdresse($adresse);

		$rp->setExpert_judiciaire($expert);

		return $rp;
	}

}
